diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/ipv4-address.h ns-3.31/src/network/utils/ipv4-address.h
--- ns-3.30.1/src/network/utils/ipv4-address.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/ipv4-address.h	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,7 @@
 #include <ostream>
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
+#include "ns3/deprecated.h"
 
 namespace ns3 {
 
@@ -77,9 +78,13 @@
   void Set (char const *address);
   /**
    * \brief Comparison operation between two Ipv4Addresses
+   *
+   * \deprecated Use the == operator (same functionality)
+   *
    * \param other address to which to compare this address
    * \return True if the addresses are equal. False otherwise.
    */
+  NS_DEPRECATED_3_31
   bool IsEqual (const Ipv4Address &other) const
   {
     return m_address == other.m_address;
@@ -105,6 +110,11 @@
    * \param os The output stream to which this Ipv4Address is printed
    */
   void Print (std::ostream &os) const;
+
+  /**
+   * \return true if address is initialized (i.e., set to something), false otherwise
+   */
+  bool IsInitialized (void) const;
   /**
     * \return true if address is 0.0.0.0; false otherwise
     */
@@ -215,6 +225,7 @@
    */
   static uint8_t GetType (void);
   uint32_t m_address; //!< IPv4 address
+  bool m_initialized; //!< IPv4 address has been explicitly initialized to a valid value.
 
   /**
    * \brief Equal to operator.
@@ -279,9 +290,13 @@
    */
   bool IsMatch (Ipv4Address a, Ipv4Address b) const;
   /**
+   *
+   * \deprecated Use the == operator (same functionality)
+   *
    * \param other a mask to compare 
    * \return true if the mask equals the mask passed as input parameter
    */
+  NS_DEPRECATED_3_31
   bool IsEqual (Ipv4Mask other) const;
   /** 
    * Get the host-order 32-bit IP mask
@@ -322,6 +337,25 @@
    */
   static Ipv4Mask GetOnes (void);
 
+  /**
+   * \brief Equal to operator.
+   *
+   * \param a the first operand.
+   * \param b the first operand.
+   * \returns true if the operands are equal.
+   */
+  friend bool operator == (Ipv4Mask const &a, Ipv4Mask const &b);
+
+  /**
+   * \brief Not equal to operator.
+   *
+   * \param a the first operand.
+   * \param b the first operand.
+   * \returns true if the operands are not equal.
+   */
+  friend bool operator != (Ipv4Mask const &a, Ipv4Mask const &b);
+
+
 private:
   uint32_t m_mask; //!< IP mask
 };
@@ -418,7 +452,11 @@
  * \param b the first operand
  * \returns true if the operands are equal
  */
-bool operator == (Ipv4Mask const &a, Ipv4Mask const &b);
+inline bool operator == (Ipv4Mask const &a, Ipv4Mask const &b)
+{
+  return (a.m_mask == b.m_mask);
+}
+
 /**
  * \brief Not equal to operator.
  *
@@ -426,7 +464,11 @@
  * \param b the first operand
  * \returns true if the operands are not equal
  */
-bool operator != (Ipv4Mask const &a, Ipv4Mask const &b);
+inline bool operator != (Ipv4Mask const &a, Ipv4Mask const &b)
+{
+  return (a.m_mask != b.m_mask);
+}
+
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/ipv6-address.cc ns-3.31/src/network/utils/ipv6-address.cc
--- ns-3.30.1/src/network/utils/ipv6-address.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/ipv6-address.cc	2020-06-27 17:38:30.000000000 -0700
@@ -282,24 +282,28 @@
 {
   NS_LOG_FUNCTION (this);
   memset (m_address, 0x00, 16);
+  m_initialized = false;
 }
 
 Ipv6Address::Ipv6Address (Ipv6Address const& addr)
 {
   // Do not add function logging here, to avoid stack overflow
   memcpy (m_address, addr.m_address, 16);
+  m_initialized = true;
 }
 
 Ipv6Address::Ipv6Address (Ipv6Address const* addr)
 {
   // Do not add function logging here, to avoid stack overflow
   memcpy (m_address, addr->m_address, 16);
+  m_initialized = true;
 }
 
 Ipv6Address::Ipv6Address (char const* address)
 {
   NS_LOG_FUNCTION (this << address);
   AsciiToIpv6Host (address, m_address);
+  m_initialized = true;
 }
 
 Ipv6Address::Ipv6Address (uint8_t address[16])
@@ -307,6 +311,7 @@
   NS_LOG_FUNCTION (this << &address);
   /* 128 bit => 16 bytes */
   memcpy (m_address, address, 16);
+  m_initialized = true;
 }
 
 Ipv6Address::~Ipv6Address ()
@@ -319,6 +324,7 @@
 {
   NS_LOG_FUNCTION (this << address);
   AsciiToIpv6Host (address, m_address);
+  m_initialized = true;
 }
 
 void Ipv6Address::Set (uint8_t address[16])
@@ -326,6 +332,7 @@
   /* 128 bit => 16 bytes */
   NS_LOG_FUNCTION (this << &address);
   memcpy (m_address, address, 16);
+  m_initialized = true;
 }
 
 void Ipv6Address::Serialize (uint8_t buf[16]) const
@@ -338,6 +345,7 @@
 {
   NS_LOG_FUNCTION (&buf);
   Ipv6Address ipv6 ((uint8_t*)buf);
+  ipv6.m_initialized = true;
   return ipv6;
 }
 
@@ -353,12 +361,40 @@
 Ipv4Address Ipv6Address::GetIpv4MappedAddress() const
 {
   NS_LOG_FUNCTION (this);
-    uint8_t buf[16];
-    Ipv4Address v4Addr;
+  uint8_t buf[16];
+  Ipv4Address v4Addr;
 
-    Serialize (buf);
-    v4Addr = Ipv4Address::Deserialize (&buf[12]);
-    return (v4Addr);
+  Serialize (buf);
+  v4Addr = Ipv4Address::Deserialize (&buf[12]);
+  return (v4Addr);
+}
+
+Ipv6Address Ipv6Address::MakeAutoconfiguredAddress (Address addr, Ipv6Address prefix)
+{
+  Ipv6Address ipv6Addr = Ipv6Address::GetAny ();
+
+  if (Mac64Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredAddress (Mac64Address::ConvertFrom (addr), Ipv6Address (prefix) );
+    }
+  else if (Mac48Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredAddress (Mac48Address::ConvertFrom (addr), Ipv6Address (prefix));
+    }
+  else if (Mac16Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredAddress (Mac16Address::ConvertFrom (addr), Ipv6Address (prefix) );
+    }
+  else if (Mac8Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredAddress (Mac8Address::ConvertFrom (addr), Ipv6Address (prefix) );
+    }
+
+  if (ipv6Addr.IsAny ())
+    {
+      NS_ABORT_MSG ("Unknown address type");
+    }
+  return ipv6Addr;
 }
 
 Ipv6Address Ipv6Address::MakeAutoconfiguredAddress (Mac16Address addr, Ipv6Address prefix)
@@ -370,6 +406,7 @@
 
   addr.CopyTo (buf);
   prefix.GetBytes (buf2);
+  memset (buf2+8, 0, 8);
 
   memcpy (buf2 + 14, buf, 2);
   buf2[11] = 0xff;
@@ -393,7 +430,7 @@
   buf2[11] = 0xff;
   buf2[12] = 0xfe;
   memcpy (buf2 + 13, buf + 3, 3);
-  buf2[8] |= 0x02;
+  buf2[8] ^= 0x02;
 
   ret.Set (buf2);
   return ret;
@@ -425,6 +462,7 @@
   buf[0] = 0;
   addr.CopyTo (&buf[1]);
   prefix.GetBytes (buf2);
+  memset (buf2+8, 0, 8);
 
   memcpy (buf2 + 14, buf, 2);
   buf2[11] = 0xff;
@@ -434,6 +472,34 @@
   return ret;
 }
 
+Ipv6Address Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Address addr)
+{
+  Ipv6Address ipv6Addr = Ipv6Address::GetAny ();
+
+  if (Mac64Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac64Address::ConvertFrom (addr));
+    }
+  else if (Mac48Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac48Address::ConvertFrom (addr));
+    }
+  else if (Mac16Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac16Address::ConvertFrom (addr));
+    }
+  else if (Mac8Address::IsMatchingType (addr))
+    {
+      ipv6Addr = Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac8Address::ConvertFrom (addr));
+    }
+
+  if (ipv6Addr.IsAny ())
+    {
+      NS_ABORT_MSG ("Unknown address type");
+    }
+  return ipv6Addr;
+}
+
 Ipv6Address Ipv6Address::MakeAutoconfiguredLinkLocalAddress (Mac16Address addr)
 {
   NS_LOG_FUNCTION (addr);
@@ -470,7 +536,7 @@
   buf2[11] = 0xff;
   buf2[12] = 0xfe;
   memcpy (buf2 + 13, buf + 3, 3);
-  buf2[8] |= 0x02;
+  buf2[8] ^= 0x02;
 
   ret.Set (buf2);
   return ret;
@@ -671,7 +737,7 @@
   return (false);
 }
 
-Ipv6Address Ipv6Address::CombinePrefix (Ipv6Prefix const& prefix)
+Ipv6Address Ipv6Address::CombinePrefix (Ipv6Prefix const& prefix) const
 {
   NS_LOG_FUNCTION (this << prefix);
   Ipv6Address ipv6;
@@ -727,13 +793,6 @@
   return (*this == allroutersI || *this == allroutersL || *this == allroutersR || *this == allroutersS);
 }
 
-bool Ipv6Address::IsAllHostsMulticast () const
-{
-  NS_LOG_FUNCTION (this);
-  static Ipv6Address allhosts ("ff02::3");
-  return (*this == allhosts);
-}
-
 bool Ipv6Address::IsAny () const
 {
   NS_LOG_FUNCTION (this);
@@ -753,6 +812,16 @@
   return false;
 }
 
+bool Ipv6Address::HasPrefix (Ipv6Prefix const& prefix) const
+{
+  NS_LOG_FUNCTION (this << prefix);
+
+  Ipv6Address masked = CombinePrefix (prefix);
+  Ipv6Address reference = Ipv6Address::GetOnes ().CombinePrefix (prefix);
+
+  return (masked == reference);
+}
+
 
 bool Ipv6Address::IsMatchingType (const Address& address)
 {
@@ -865,6 +934,12 @@
   return false;
 }
 
+bool Ipv6Address::IsInitialized (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return (m_initialized);
+}
+
 std::ostream& operator << (std::ostream& os, Ipv6Address const& address)
 {
   address.Print (os);
@@ -883,18 +958,43 @@
 {
   NS_LOG_FUNCTION (this);
   memset (m_prefix, 0x00, 16);
+  m_prefixLength = 64;
 }
 
 Ipv6Prefix::Ipv6Prefix (char const* prefix)
 {
   NS_LOG_FUNCTION (this << prefix);
   AsciiToIpv6Host (prefix, m_prefix);
+  m_prefixLength = GetMinimumPrefixLength ();
 }
 
 Ipv6Prefix::Ipv6Prefix (uint8_t prefix[16])
 {
   NS_LOG_FUNCTION (this << &prefix);
   memcpy (m_prefix, prefix, 16);
+  m_prefixLength = GetMinimumPrefixLength ();
+}
+
+Ipv6Prefix::Ipv6Prefix (char const* prefix, uint8_t prefixLength)
+{
+  NS_LOG_FUNCTION (this << prefix);
+  AsciiToIpv6Host (prefix, m_prefix);
+
+  uint8_t autoLength = GetMinimumPrefixLength ();
+  NS_ASSERT_MSG (autoLength <= prefixLength, "Ipv6Prefix: address and prefix are not compatible: " << Ipv6Address (prefix) << "/" << +prefixLength);
+
+  m_prefixLength = prefixLength;
+}
+
+Ipv6Prefix::Ipv6Prefix (uint8_t prefix[16], uint8_t prefixLength)
+{
+  NS_LOG_FUNCTION (this << &prefix);
+  memcpy (m_prefix, prefix, 16);
+
+  uint8_t autoLength = GetMinimumPrefixLength ();
+  NS_ASSERT_MSG (autoLength <= prefixLength, "Ipv6Prefix: address and prefix are not compatible: " << Ipv6Address (prefix) << "/" << +prefixLength);
+
+  m_prefixLength = prefixLength;
 }
 
 Ipv6Prefix::Ipv6Prefix (uint8_t prefix)
@@ -905,6 +1005,7 @@
   unsigned int i=0;
 
   memset (m_prefix, 0x00, 16);
+  m_prefixLength = prefix;
 
   NS_ASSERT (prefix <= 128);
 
@@ -935,11 +1036,13 @@
 Ipv6Prefix::Ipv6Prefix (Ipv6Prefix const& prefix)
 {
   memcpy (m_prefix, prefix.m_prefix, 16);
+  m_prefixLength = prefix.m_prefixLength;
 }
 
 Ipv6Prefix::Ipv6Prefix (Ipv6Prefix const* prefix)
 {
   memcpy (m_prefix, prefix->m_prefix, 16);
+  m_prefixLength = prefix->m_prefixLength;
 }
 
 Ipv6Prefix::~Ipv6Prefix ()
@@ -1006,21 +1109,41 @@
 uint8_t Ipv6Prefix::GetPrefixLength () const
 {
   NS_LOG_FUNCTION (this);
-  uint8_t i = 0;
+  return m_prefixLength;
+}
+
+void Ipv6Prefix::SetPrefixLength (uint8_t prefixLength)
+{
+  NS_LOG_FUNCTION (this);
+  m_prefixLength = prefixLength;
+}
+
+uint8_t Ipv6Prefix::GetMinimumPrefixLength () const
+{
+  NS_LOG_FUNCTION (this);
+
   uint8_t prefixLength = 0;
+  bool stop = false;
 
-  for(i = 0; i < 16; i++)
+  for(int8_t i=15; i>=0 && !stop; i--)
     {
       uint8_t mask = m_prefix[i];
 
-      while(mask != 0)
+      for(uint8_t j=0; j<8 && !stop; j++)
         {
-          mask = mask << 1;
-          prefixLength++;
+          if ((mask & 1) == 0)
+            {
+              mask = mask >> 1;
+              prefixLength++;
+            }
+          else
+            {
+              stop = true;
+            }
         }
     }
 
-  return prefixLength;
+  return 128 - prefixLength;
 }
 
 bool Ipv6Prefix::IsEqual (const Ipv6Prefix& other) const
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/ipv6-address.h ns-3.31/src/network/utils/ipv6-address.h
--- ns-3.30.1/src/network/utils/ipv6-address.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/ipv6-address.h	2020-06-27 17:38:30.000000000 -0700
@@ -101,9 +101,12 @@
   /**
    * \brief Comparison operation between two Ipv6Addresses.
    *
-   * \param other the IPv6 address to which to compare thisaddress
+   * \deprecated Use the == operator (same functionality)
+   *
+   * \param other the IPv6 address to which to compare this address
    * \return true if the addresses are equal, false otherwise
    */
+  NS_DEPRECATED_3_31
   bool IsEqual (const Ipv6Address& other) const;
 
   /**
@@ -141,6 +144,17 @@
   Ipv4Address GetIpv4MappedAddress () const;
 
   /**
+   * \brief Make the autoconfigured IPv6 address from a Mac address.
+   *
+   * Actually the MAC supported are: Mac8, Mac16, Mac48, and Mac64.
+   *
+   * \param addr the MAC address.
+   * \param prefix the IPv6 prefix
+   * \return autoconfigured IPv6 address
+   */
+  static Ipv6Address MakeAutoconfiguredAddress (Address addr, Ipv6Address prefix);
+
+  /**
    * \brief Make the autoconfigured IPv6 address with Mac16Address.
    *
    * The EUI-64 scheme used is based on the \RFC{4944}.
@@ -182,6 +196,16 @@
   static Ipv6Address MakeAutoconfiguredAddress (Mac8Address addr, Ipv6Address prefix);
 
   /**
+   * \brief Make the autoconfigured link-local IPv6 address from a Mac address.
+   *
+   * Actually the MAC supported are: Mac8, Mac16, Mac48, and Mac64.
+   *
+   * \param mac the MAC address.
+   * \return autoconfigured link-local IPv6 address
+   */
+  static Ipv6Address MakeAutoconfiguredLinkLocalAddress (Address mac);
+
+  /**
    * \brief Make the autoconfigured link-local IPv6 address with Mac16Address.
    *
    * The EUI-64 scheme used is based on the \RFC{4944}.
@@ -257,16 +281,6 @@
   bool IsAllRoutersMulticast () const;
 
   /**
-   * \brief If the IPv6 address is "all hosts multicast" (ff02::3/8).
-   *
-   * \deprecated This function is deprecated because the address has been removed from RFCs.
-   *
-   * \return true if "all hosts multicast", false otherwise
-   */
-  NS_DEPRECATED
-  bool IsAllHostsMulticast () const;
-
-  /**
    * \brief If the IPv6 address is a link-local address (fe80::/64).
    * \return true if the address is link-local, false otherwise
    */
@@ -291,12 +305,19 @@
   bool IsDocumentation () const;
 
   /**
+   * \brief Compares an address and a prefix.
+   * \param prefix the prefix to compare with
+   * \return true if the address has the given prefix
+   */
+  bool HasPrefix (Ipv6Prefix const& prefix) const;
+
+  /**
    * \brief Combine this address with a prefix.
    * \param prefix a IPv6 prefix
    * \return an IPv6 address that is this address combined
    * (bitwise AND) with a prefix, yielding an IPv6 network address.
    */
-  Ipv6Address CombinePrefix (Ipv6Prefix const & prefix);
+  Ipv6Address CombinePrefix (Ipv6Prefix const & prefix) const;
 
   /**
    * \brief If the Address matches the type.
@@ -324,6 +345,11 @@
   static Ipv6Address ConvertFrom (const Address& address);
 
   /**
+   * \return true if address is initialized (i.e., set to something), false otherwise
+   */
+  bool IsInitialized (void) const;
+
+  /**
    * \brief Get the 0 (::) Ipv6Address.
    * \return the :: Ipv6Address representation
    */
@@ -389,6 +415,7 @@
    * \brief The address representation on 128 bits (16 bytes).
    */
   uint8_t m_address[16];
+  bool m_initialized; //!< IPv6 address has been explicitly initialized to a valid value.
 
   /**
    * \brief Equal to operator.
@@ -435,17 +462,39 @@
 
   /**
    * \brief Constructs an Ipv6Prefix by using the input 16 bytes.
+   *
+   * The prefix length is calculated as the minimum prefix length, i.e.,
+   * 2001:db8:cafe:: will have a 47 bit prefix length.
+   *
    * \param prefix the 128-bit prefix
    */
   Ipv6Prefix (uint8_t prefix[16]);
 
   /**
    * \brief Constructs an Ipv6Prefix by using the input string.
+   *
+   * The prefix length is calculated as the minimum prefix length, i.e.,
+   * 2001:db8:cafe:: will have a 47 bit prefix length.
+   *
    * \param prefix the 128-bit prefix
    */
   Ipv6Prefix (char const* prefix);
 
   /**
+   * \brief Constructs an Ipv6Prefix by using the input 16 bytes.
+   * \param prefix the 128-bit prefix
+   * \param prefixLength the prefix length
+   */
+  Ipv6Prefix (uint8_t prefix[16], uint8_t prefixLength);
+
+  /**
+   * \brief Constructs an Ipv6Prefix by using the input string.
+   * \param prefix the 128-bit prefix
+   * \param prefixLength the prefix length
+   */
+  Ipv6Prefix (char const* prefix, uint8_t prefixLength);
+
+  /**
    * \brief Constructs an Ipv6Prefix by using the input number of bits.
    * \param prefix number of bits of the prefix (0 - 128)
    * \note A valid number of bits is between 0 and 128).
@@ -490,10 +539,26 @@
   uint8_t GetPrefixLength () const;
 
   /**
+   * \brief Set prefix length.
+   * \param prefixLength the prefix length
+   */
+  void SetPrefixLength (uint8_t prefixLength);
+
+   /**
+    * \brief Get the minimum prefix length, i.e., 128 - the length of the largest sequence trailing zeroes.
+    * \return minimum prefix length
+    */
+  uint8_t GetMinimumPrefixLength () const;
+
+  /**
    * \brief Comparison operation between two Ipv6Prefix.
+   *
+   * \deprecated Use the == operator (same functionality)
+   *
    * \param other the IPv6 prefix to which to compare this prefix
    * \return true if the prefixes are equal, false otherwise
    */
+  NS_DEPRECATED_3_31
   bool IsEqual (const Ipv6Prefix& other) const;
 
   /**
@@ -529,6 +594,11 @@
   uint8_t m_prefix[16];
 
   /**
+   * \brief The prefix length.
+   */
+  uint8_t m_prefixLength;
+
+  /**
    * \brief Equal to operator.
    *
    * \param a the first operand
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/mac16-address.cc ns-3.31/src/network/utils/mac16-address.cc
--- ns-3.30.1/src/network/utils/mac16-address.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/mac16-address.cc	2020-06-27 17:38:30.000000000 -0700
@@ -152,10 +152,63 @@
 Mac16Address::GetType (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
+
   static uint8_t type = Address::Register ();
   return type;
 }
 
+Mac16Address
+Mac16Address::GetBroadcast (void)
+{
+  NS_LOG_FUNCTION_NOARGS ();
+
+  static Mac16Address broadcast = Mac16Address ("ff:ff");
+  return broadcast;
+}
+
+Mac16Address
+Mac16Address::GetMulticast (Ipv6Address address)
+{
+  NS_LOG_FUNCTION (address);
+
+  uint8_t ipv6AddrBuf[16];
+  address.GetBytes(ipv6AddrBuf);
+
+  uint8_t addrBuf[2];
+
+  addrBuf[0] = 0x80 | (ipv6AddrBuf[14] & 0x1F);
+  addrBuf[1] = ipv6AddrBuf[15];
+
+  Mac16Address multicastAddr;
+  multicastAddr.CopyFrom (addrBuf);
+
+  return multicastAddr;
+}
+
+bool
+Mac16Address::IsBroadcast (void) const
+{
+  NS_LOG_FUNCTION (this);
+  if (m_address[0] == 0xff && m_address[1] == 0xff)
+    {
+      return true;
+    }
+  return false;
+}
+
+bool
+Mac16Address::IsMulticast (void) const
+{
+  NS_LOG_FUNCTION (this);
+  uint8_t val = m_address[0];
+  val >>= 5;
+  if (val == 0x4)
+    {
+      return true;
+    }
+  return false;
+}
+
 std::ostream & operator<< (std::ostream& os, const Mac16Address & address)
 {
   uint8_t ad[2];
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/mac16-address.h ns-3.31/src/network/utils/mac16-address.h
--- ns-3.30.1/src/network/utils/mac16-address.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/mac16-address.h	2020-06-27 17:38:30.000000000 -0700
@@ -86,6 +86,51 @@
    */
   static Mac16Address Allocate (void);
 
+  /**
+   * \returns the broadcast address (0xFFFF)
+   */
+  static Mac16Address GetBroadcast (void);
+
+  /**
+   * Returns the multicast address associated with an IPv6 address
+   * according to RFC 4944 Section 9.
+   * An IPv6 packet with a multicast destination address (DST),
+   * consisting of the sixteen octets DST[1] through DST[16], is
+   * transmitted to the following 802.15.4 16-bit multicast address:
+
+  \verbatim
+    0                   1
+    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5
+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+   |1 0 0|DST[15]* |   DST[16]     |
+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+  \endverbatim
+
+   * Here, DST[15]* refers to the last 5 bits in octet DST[15], that is,
+   * bits 3-7 within DST[15].  The initial 3-bit pattern of "100" follows
+   * the 16-bit address format for multicast addresses (Section 12).
+   *
+   * \returns the multicast 16-bit address.
+   */
+
+  static Mac16Address GetMulticast (Ipv6Address address);
+
+  /**
+   * Checks if the address is a broadcast address according
+   * to 802.15.4 scheme (i.e., 0xFFFF).
+   *
+   * \returns true if the address is 0xFFFF
+   */
+  bool IsBroadcast (void) const;
+
+  /**
+   * Checks if the address is a multicast address according
+   * to RFC 4944 Section 9 (i.e., if its first 3 bits are 100).
+   *
+   * \returns true if the address is in the range 0x8000 - 0x9FFF
+   */
+  bool IsMulticast (void) const;
+
 private:
   /**
    * \returns a new Address instance
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/packet-socket.cc ns-3.31/src/network/utils/packet-socket.cc
--- ns-3.30.1/src/network/utils/packet-socket.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/packet-socket.cc	2020-06-27 17:38:30.000000000 -0700
@@ -343,6 +343,7 @@
 
   bool error = false;
   Address dest = ad.GetPhysicalAddress ();
+  uint32_t pktSize = p->GetSize (); // device->Send() may modify the packet
   if (ad.IsSingleDevice ())
     {
       Ptr<NetDevice> device = m_node->GetDevice (ad.GetSingleDevice ());
@@ -366,7 +367,7 @@
     }
   if (!error)
     {
-      NotifyDataSent (p->GetSize ());
+      NotifyDataSent (pktSize);
       NotifySend (GetTxAvailable ());
     }
 
@@ -378,7 +379,7 @@
     }
   else
     {
-      return p->GetSize ();
+      return pktSize;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/queue.cc ns-3.31/src/network/utils/queue.cc
--- ns-3.30.1/src/network/utils/queue.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/queue.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,12 +36,6 @@
   static TypeId tid = TypeId ("ns3::QueueBase")
     .SetParent<Object> ()
     .SetGroupName ("Network")
-    .AddAttribute ("MaxSize",
-                   "The max queue size",
-                   QueueSizeValue (QueueSize ("100p")),
-                   MakeQueueSizeAccessor (&QueueBase::SetMaxSize,
-                                          &QueueBase::GetMaxSize),
-                   MakeQueueSizeChecker ())
     .AddTraceSource ("PacketsInQueue",
                      "Number of packets currently stored in the queue",
                      MakeTraceSourceAccessor (&QueueBase::m_nPackets),
@@ -67,6 +61,7 @@
   m_nTotalDroppedPacketsAfterDequeue (0)
 {
   NS_LOG_FUNCTION (this);
+  m_maxSize = QueueSize (QueueSizeUnit::PACKETS, std::numeric_limits<uint32_t>::max ());
 }
 
 QueueBase::~QueueBase ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/wscript ns-3.31/src/network/wscript
--- ns-3.30.1/src/network/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -24,7 +24,6 @@
         'model/tag-buffer.cc',
         'model/trailer.cc',
         'utils/address-utils.cc',
-        'utils/ascii-file.cc',
         'utils/crc32.cc',
         'utils/data-rate.cc',
         'utils/drop-tail-queue.cc',
@@ -87,6 +86,12 @@
         'test/packet-socket-apps-test-suite.cc',
         ]
 
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        network_test.source.extend([
+        #   'test/network-examples-test-suite.cc',
+            ])
+    
     headers = bld(features='ns3header')
     headers.module = 'network'
     headers.source = [
@@ -111,8 +116,6 @@
         'model/tag-buffer.h',
         'model/trailer.h',
         'utils/address-utils.h',
-        'utils/ascii-file.h',
-        'utils/ascii-test.h',
         'utils/crc32.h',
         'utils/data-rate.h',
         'utils/drop-tail-queue.h',
